HexToUpperString(hex)
{
	StringTrimLeft, ret, hex, 0x2
	StringUpper, ret, ret
	return ret
}

;
;	UTF-8
;		110a aaaa 10bb bbbb
;	UCS-2 (2)
;		0000 0aaa aabb bbbb
;	UCS-2 (16)
;		0x80 - 0x7ff
;	0x100 ȉ͂ЂƂ]Ƀ[
;
TwoOctets(bit_a, bit_b)
{
	hex := (bit_a << 0x6) + bit_b
	ret := HexToUpperString(hex)
	if (hex < 0x100)
	{
		ret = 0%ret%
	}
	ret = {U+0%ret%}
	return ret
}

;
;	UTF-8
;		1110 aaaa 10bb bbbb 10cc cccc
;	UCS-2 (2)
;		aaaa bbbb bbcc cccc
;	UCS-2 (16)
;		0x800 - 0xffff
;	0x1000 ȉ̂݁AЂƂ[
;
ThreeOctets(bit_a, bit_b, bit_c)
{
	hex := (bit_a << 0xc) + (bit_b << 0x6) + bit_c
	ret := HexToUpperString(hex)
	if (hex < 0x1000)
	{
		ret = 0%ret%
	}
	ret = {U+%ret%}
	return ret
}

;
;	UTF-8
;		1111 0aaa 10bb bbbb 10cc cccc 10dd dddd
;	UCS-2 (2)
;		0000 0000 000a aabb bbbb cccc ccdd dddd
;	UCS-2 (16)
;		0x10000 - 0x10ffff
;	UCS-2 (16, Surrogate)
;		[0xd800 + 0xdc00] - [0xdbff + 0xdfff]
;	[ߕsv
;
FourOctets(bit_a, bit_b, bit_c, bit_d)
{
	hex := (bit_a << 0x12) + (bit_b << 0xc) + (bit_c << 0x6) + bit_d

	diff := hex - 0x10000
	highS := diff // 0x400
	Transform, lowS, mod, %diff%, 0x400
	highS += 0xd800
	highS := HexToUpperString(highS)
	lowS += 0xdc00
	lowS := HexToUpperString(lowS)

	ret = {U+%highS%}{U+%lowS%}
	return ret
}


Conv_utf16(ByRef text)
{
	SetFormat, integer, H

	;
	;	16i` "0x" 
	;	a-f 啶ɕϊ
	;
	Transform, text, Unicode,
	ret =
	cnt = 0x0
	Loop, parse, text
	{
		num := Asc(A_LoopField)
		if (cnt <> 0x0)
		{
			cnt--
			if (cnt = 0x2)
			{
				bit_b := num & 0x3f
			}
			else if (cnt = 0x1)
			{
				if (len = 0x3)
				{
					bit_b := num & 0x3f
				}
				else
				{
					bit_c := num & 0x3f
				}
			}
			else if (cnt = 0x0)
			{
				if (len = 0x2)
				{
					bit_b := num & 0x3f
					val := TwoOctets(bit_a, bit_b)
				}
				else if (len = 0x3)
				{
					bit_c := num & 0x3f
					val := ThreeOctets(bit_a, bit_b, bit_c)
				}
				else
				{
					bit_d := num & 0x3f
					val := FourOctets(bit_a, bit_b, bit_c, bit_d)
				}
				ret = %ret%%val%
			}
		}
		else if (num < 0x80)
		{
			val := HexToUpperString(num)
			if (num < 0x10)
			{
				val = 0%val%
			}
			ret = %ret%{U+00%val%}
		}
		else if (num < 0xe0)
		{
			len = 0x2
			cnt = 0x1
			bit_a := num & 0x1f
		}
		else if (num < 0xf0)
		{
			len = 0x3
			cnt = 0x2
			bit_a := num & 0xf
		}
		else
		{
			len = 0x4
			cnt = 0x3
			bit_a := num & 0x7
		}
	}
	SetFormat, integer, D
	text = %ret%
}
